<% require 'active_support/inflector' %>
<% @rows.each do |row| -%>

coreo_aws_rule "aws-guardduty-<%= row[:gd_name].underscore.gsub('_','-').strip -%>" do
  action :define
  service :<%= row[:gd_service].strip -%> 
  link "https://kb.securestate.vmware.com/aws-gd-<%= row[:gd_name].underscore.gsub('_','-').strip -%>.html"
  display_name "AWS GuardDuty <%= row[:gd_name].strip -%>"
  description "<%= row[:gd_description].strip -%>"
  category "<%= row[:gd_category].strip -%>"
  suggested_action "<%= row[:gd_suggested_action].strip -%>"
  level "<%= row[:gd_level].strip -%>"
  objectives [""]
  audit_objects [""]
  operators [""]
  raise_when [//]
  id_map [""]
  meta_rule_query <<~QUERY
  {
    findings as var(func: <%%= filter['guard_duty_finding'] %>) {
      f_type as finding_type 
    }
    instances as var(func: has(instance)) {}
    accounts as var(func: has(account)) {}
    gd_services           as var(func: <%%= filter['guard_duty_service'] %>) {}
    gd_actions            as var(func: <%%= filter['guard_duty_action'] %>) {}
    gd_port_probe_actions as var(func: <%%= filter['guard_duty_port_probe_action'] %>) {}
    gd_port_probe_details as var(func: <%%= filter['guard_duty_port_probe_detail'] %>) {}
    gd_remote_ip_details  as var(func: <%%= filter['guard_duty_remote_ip_detail'] %>) {}
    gd_local_port_details as var(func: <%%= filter['guard_duty_local_port_detail'] %>) {}
    gd_countries          as var(func: <%%= filter['guard_duty_country'] %>) {}
    gd_remote_ip_org      as var(func: <%%= filter['guard_duty_remote_ip_org'] %>) {}

    base_query as query(func: uid(findings)) @filter(eq(val(f_type), "<%= row[:gd_finding_type].strip -%>")) {
      <%%= default_predicates %>
      finding_type
      created_at
      updated_at
      title
      description
    }
    visualization(func: uid(base_query)) {
      <%%= default_predicates %>
      finding_type
      created_at
      updated_at
      title
      description
      relates_to @filter(uid(instances, accounts, gd_services)) {
        <%%= default_predicates %>
        instance_id
        public_dns_name
        public_ip_address
        private_dns_name
        private_dns_address
        AWS_account:account_id
        event_first_seen
        event_last_seen
        event_count:count
        relates_to @filter(uid(gd_actions)) {
          <%%= default_predicates %>
          action_type
          relates_to @filter(uid(gd_port_probe_actions)) {
            <%%= default_predicates %>
            relates_to @filter(uid(gd_port_probe_details)) {
              <%%= default_predicates %>
              relates_to @filter(uid(gd_remote_ip_details, gd_local_port_details)) {
                <%%= default_predicates %>
                port
                port_name
                ip_address_v4
                geo_location_lat
                geo_location_lon
                relates_to @filter(uid(gd_countries, gd_remote_ip_org)) {
                  <%%= default_predicates %>
                  country_name
                  isp
                  org
                  asn
                  asn_org
                }
              }
            }
          }
        }
      }
    }
  }
  QUERY
  meta_rule_node_triggers({
                            'guard_duty_finding' => [],
                            'guard_duty_service' => ['event_last_seen', 'count'],
                            'guard_duty_action' => [],
                            'guard_duty_port_probe_action' => [],
                            'guard_duty_port_probe_detail' => [],
                            'guard_duty_remote_ip_detail' => [],
                            'guard_duty_local_port_detail' => [],
                            'guard_duty_country' => [],
                            'guard_duty_remote_ip_org' => []
                          })
end
<% end %>
